'''
Created on 02.01.2019

@author: ED
'''

class TMC4671_register:
    """
    Define all registers of the TMC4671.
    """
    CHIPINFO_DATA                      = 0x00
    CHIPINFO_ADDR                      = 0x01
    ADC_RAW_DATA                       = 0x02
    ADC_RAW_ADDR                       = 0x03
    dsADC_MCFG_B_MCFG_A                = 0x04
    dsADC_MCLK_A                       = 0x05
    dsADC_MCLK_B                       = 0x06
    dsADC_MDEC_B_MDEC_A                = 0x07
    ADC_I1_SCALE_OFFSET                = 0x08
    ADC_I0_SCALE_OFFSET                = 0x09
    ADC_I_SELECT                       = 0x0a
    ADC_I1_I0_EXT                      = 0x0b
    DS_ANALOG_INPUT_STAGE_CFG          = 0x0c
    AENC_0_SCALE_OFFSET                = 0x0d
    AENC_1_SCALE_OFFSET                = 0x0e
    AENC_2_SCALE_OFFSET                = 0x0f
    AENC_SELECT                        = 0x11
    ADC_IWY_IUX                        = 0x12
    ADC_IV                             = 0x13
    AENC_WY_UX                         = 0x15
    AENC_VN                            = 0x16
    PWM_POLARITIES                     = 0x17
    PWM_MAXCNT                         = 0x18
    PWM_BBM_H_BBM_L                    = 0x19
    PWM_SV_CHOP                        = 0x1a
    MOTOR_TYPE_N_POLE_PAIRS            = 0x1b
    PHI_E_EXT                          = 0x1c
    PHI_M_EXT                          = 0x1d
    POSITION_EXT                       = 0x1e
    OPENLOOP_MODE                      = 0x1f
    OPENLOOP_ACCELERATION              = 0x20
    OPENLOOP_VELOCITY_TARGET           = 0x21
    OPENLOOP_VELOCITY_ACTUAL           = 0x22
    OPENLOOP_PHI                       = 0x23
    UQ_UD_EXT                          = 0x24
    ABN_DECODER_MODE                   = 0x25
    ABN_DECODER_PPR                    = 0x26
    ABN_DECODER_COUNT                  = 0x27
    ABN_DECODER_COUNT_N                = 0x28
    ABN_DECODER_PHI_E_PHI_M_OFFSET     = 0x29
    ABN_DECODER_PHI_E_PHI_M            = 0x2a
    ABN_2_DECODER_MODE                 = 0x2c
    ABN_2_DECODER_PPR                  = 0x2d
    ABN_2_DECODER_COUNT                = 0x2e
    ABN_2_DECODER_COUNT_N              = 0x2f
    ABN_2_DECODER_PHI_M_OFFSET         = 0x30
    ABN_2_DECODER_PHI_M                = 0x31
    HALL_MODE                          = 0x33
    HALL_POSITION_060_000              = 0x34
    HALL_POSITION_180_120              = 0x35
    HALL_POSITION_300_240              = 0x36
    HALL_PHI_E_PHI_M_OFFSET            = 0x37
    HALL_DPHI_MAX                      = 0x38
    HALL_PHI_E_INTERPOLATED_PHI_E      = 0x39
    HALL_PHI_M                         = 0x3a
    AENC_DECODER_MODE                  = 0x3b
    AENC_DECODER_N_THRESHOLD           = 0x3c
    AENC_DECODER_PHI_A_RAW             = 0x3d
    AENC_DECODER_PHI_A_OFFSET          = 0x3e
    AENC_DECODER_PHI_A                 = 0x3f
    AENC_DECODER_PPR                   = 0x40
    AENC_DECODER_COUNT                 = 0x41
    AENC_DECODER_COUNT_N               = 0x42
    AENC_DECODER_PHI_E_PHI_M_OFFSET    = 0x45
    AENC_DECODER_PHI_E_PHI_M           = 0x46
    AENC_DECODER_POSITION              = 0x47
    PIDIN_VELOCITY_TARGET              = 0x4b
    PIDIN_POSITION_TARGET              = 0x4c
    CONFIG_DATA                        = 0x4d
    CONFIG_ADDR                        = 0x4e
    VELOCITY_SELECTION                 = 0x50
    POSITION_SELECTION                 = 0x51
    PHI_E_SELECTION                    = 0x52
    PHI_E                              = 0x53
    PID_FLUX_P_FLUX_I                  = 0x54
    PID_TORQUE_P_TORQUE_I              = 0x56
    PID_VELOCITY_P_VELOCITY_I          = 0x58
    PID_POSITION_P_POSITION_I          = 0x5a
    PID_TORQUE_FLUX_TARGET_DDT_LIMITS  = 0x5c
    PIDOUT_UQ_UD_LIMITS                = 0x5d
    PID_TORQUE_FLUX_LIMITS             = 0x5e
    PID_ACCELERATION_LIMIT             = 0x5f
    PID_VELOCITY_LIMIT                 = 0x60
    PID_POSITION_LIMIT_LOW             = 0x61
    PID_POSITION_LIMIT_HIGH            = 0x62
    MODE_RAMP_MODE_MOTION              = 0x63
    PID_TORQUE_FLUX_TARGET             = 0x64
    PID_TORQUE_FLUX_OFFSET             = 0x65
    PID_VELOCITY_TARGET                = 0x66
    PID_VELOCITY_OFFSET                = 0x67
    PID_POSITION_TARGET                = 0x68
    PID_TORQUE_FLUX_ACTUAL             = 0x69
    PID_VELOCITY_ACTUAL                = 0x6a
    PID_POSITION_ACTUAL                = 0x6b
    PID_ERROR_DATA                     = 0x6c
    PID_ERROR_ADDR                     = 0x6d
    INTERIM_DATA                       = 0x6e
    INTERIM_ADDR                       = 0x6f
    WATCHDOG_CFG                       = 0x74
    ADC_VM_LIMITS                      = 0x75
    TMC4671_INPUTS_RAW                 = 0x76
    TMC4671_OUTPUTS_RAW                = 0x77
    STEP_WIDTH                         = 0x78
    UART_BPS                           = 0x79
    UART_ADDRS                         = 0x7A
    GPIO_dsADCI_CONFIG                 = 0x7B
    STATUS_FLAGS                       = 0x7c
    STATUS_MASK                        = 0x7d
